signature ID = sig

(* Hashed strings *)

type T 

val intern: string -> T
val tostr: T -> string

val hashcode: T -> int 
val new: unit -> T
val new_from: string -> T

val == : T -> T -> bool

val lexlt : T -> T -> bool
val lookup_field: T -> (T*'a) list -> 'a option

end


