signature SYNTH = sig

structure Globals: GLOBALS
structure Trm: TRM
structure Typ: TYP
structure TEnv: TENV
structure Leq: LEQ
sharing Trm.Typ = Typ
    and Leq.Typ = Typ
    and Typ.Globals = Globals
    and TEnv.Typ = Typ
include GLOBALS

val synth: TEnv.T -> Trm.T -> Typ.T

val setquerytenv: TEnv.T -> unit

end
